=== debian/changelog ===
cgal (5.0.3-1ubuntu1) groovy; urgency=medium

  * debian/control
    - build depend on g++-9 and gcc-9 for riscv64 in an attempt to
      fix a FTBFS

 -- Ken VanDine <ken.vandine@canonical.com>  Wed, 19 Aug 2020 14:14:44 -0400

cgal (5.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Add Suggests: libceres-dev to libcal-demo.
  * Remove duplicate Suggests: libglpk-dev for libcgal-demo.

 -- Joachim Reichel <reichel@debian.org>  Mon, 03 Aug 2020 17:57:06 +0200
